#include "serial_dbg.h"
#include "master.h"

#include "uart.h"
//#include "serial.h"
//#include "ByteQueue.h"
#include "ToCoNet.h"
#include <utils.h>
#include <string.h>
#include <AppHardwareApi.h>

#define MAX_TX  128
//tsSerialPortSetup g_UartPort;
//uint8 au8SerialTxBuffer[256];
//uint8 au8SerialRxBuffer[256];

char g_u8TxBuffer[MAX_TX];
int16 g_i16Size;
uint8 g_u8TxReadPt,g_u8TxWritePt;



void cvRecieved(uint8 u8SerialPort,uint8 u8Char)
{

}


void cbTranmitted(uint8 u8SerialPort)
{
/*     if (!QUEUE_bEmpty(asSerialPorts[u8SerialPort].sTxQueue)) {
        UART_vTxChar(u8SerialPort,QUEUE_u8RemoveItem(asSerialPorts[u8SerialPort].sTxQueue,FALSE));
    }
 */
    g_i16Size--;
    if(g_i16Size > 0)
    {
 //       vPortSetHi(DO1);
        g_u8TxReadPt++;
        UART_vTxChar(u8SerialPort, g_u8TxBuffer[g_u8TxReadPt]);
    }

}




void SerialDebugInit()
{
/*    memset(&g_UartPort, 0, sizeof(tsSerialPortSetup));
    g_UartPort.pu8SerialRxQueueBuffer = au8SerialRxBuffer;
    g_UartPort.pu8SerialTxQueueBuffer = au8SerialRxBuffer;
    g_UartPort.u32BaudRate = 115200;
    g_UartPort.u16AHI_UART_RTS_LOW = 0xffff;
    g_UartPort.u16AHI_UART_RTS_HIGH = 0xffff;
	g_UartPort.u16SerialRxQueueSize = sizeof(au8SerialRxBuffer);
	g_UartPort.u16SerialTxQueueSize = sizeof(au8SerialTxBuffer);
	g_UartPort.u8SerialPort = E_AHI_UART_0 ;
	g_UartPort.u8RX_FIFO_LEVEL = E_AHI_UART_FIFO_LEVEL_1;
	
	SERIAL_vInit(&g_UartPort);*/

    g_i16Size = g_u8TxReadPt = g_u8TxWritePt = 0;
    memset(g_u8TxBuffer, 'Q', MAX_TX);
    tsUartOpt opt;
    opt.bHwFlowEnabled = FALSE;
    opt.bParityEnabled = FALSE;
    opt.u8ParityType = 0;
    opt.u8StopBit = E_AHI_UART_1_STOP_BIT;
    opt.u8WordLen = 8;

    UART_vInit(E_AHI_UART_0, cvRecieved, cbTranmitted, 115200, E_AHI_UART_FIFO_LEVEL_1, &opt);
    UART_vSetTxInterrupt(E_AHI_UART_0, TRUE);

}


 void SerialDebugSend(char*  pMsg, int16 size)
{
    int i;

    for(i = 0; i < size; i++)
    {
        g_u8TxBuffer[i] = *(pMsg + i);
    }
    g_i16Size = size;
    //g_u8TxSize = 1;
    g_u8TxReadPt = 0;
    g_u8TxWritePt = size;
    UART_vTxChar(E_AHI_UART_0, g_u8TxBuffer[g_u8TxReadPt]);
}


 PUBLIC bool IsSerialDebugSending()
{
    if(g_i16Size > 0)
    {
        return TRUE;
    }
    return FALSE;
}
